// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "VNIfEventParser.hpp"
#include "VNSceneEventsParser.hpp"

using namespace Dawn;

std::vector<std::string> VNIfEventParser::getRequiredAttributes() {
  return { "key", "value" };
}

std::map<std::string, std::string> VNIfEventParser::getOptionalAttributes() {
  return {};
}

int32_t VNIfEventParser::onParse(
  Xml *node,
  std::map<std::string, std::string> values,
  struct VNIfEvent *out,
  std::string *error
) {
  //Get the key and value
  out->key = values["key"];
  out->value = values["value"];

  return (VNSceneEventsParser()).parse(node, &out->events, error);
}