// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/XmlParser.hpp"

namespace Dawn {
  struct VNSetFont {
    std::string font;
    std::string style;
    std::string fontSize;
    std::string color;
  };

  class VNSetDefaultFontEventParser : public XmlParser<struct VNSetFont> {
    protected:
      std::vector<std::string> getRequiredAttributes() override;
      std::map<std::string, std::string> getOptionalAttributes() override;
      int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct VNSetFont *out,
        std::string *error
      ) override;
  };
}